function [weightedMatrix]=calculateTFIDF(originalMatrix)

    [numberOfRows,numberOfColumns]=size(originalMatrix);
    
    %max computes the maximum for columns, but we want for rows
    maxValuesForRows=max(originalMatrix');
    
    normalizedMatrix=zeros(numberOfRows,numberOfColumns);
    for i=1:numberOfRows 
        normalizedMatrix(i,:)=originalMatrix(i,:)./maxValuesForRows(i);
    end;
    
    normalizedMatrix;
    
    documentFrequencies=zeros(1,numberOfColumns);
    for i=1:numberOfColumns
        currentFrequency=0;
        for j=1:numberOfRows
            if originalMatrix(j,i)~=0
                currentFrequency=currentFrequency+1;
            end
        end;
        documentFrequencies(i)=currentFrequency;
    end;
    
    documentFrequencies;
 
    inverseDocumentFrequencies=log(numberOfRows./documentFrequencies);
    
    weightedMatrix=zeros(numberOfRows,numberOfColumns);
    
    for i=1:numberOfColumns 
        weightedMatrix(:,i)=normalizedMatrix(:,i).*inverseDocumentFrequencies(i);
    end;

    weightedMatrix;
end